/***************************************************************************/
/*                                                                         */
/*                                                                         */
/*                   (c) 1993,1994 by Kaya Memisoglu                       */
/*                                    aka Marc van Shaney                  */
/*                                                                         */
/* Die kommerzielle Nutzung des Source-Codes ohne meine schriftliche       */
/* Genehmigung ist untersagt. Desweiteren hafte ich fr keinerlei          */
/* Schaden den das Programm verursacht.                                    */
/*                                                                         */
/* Geschrieben mit Borland C++ 3.1                                         */
/*     Borland C++ ist eingetragenes Warenzeichen der                      */
/*                                  Borland Inernational INC               */
/*                                                                         */
/*                                                                         */
/* 18.1.1994 - Kaya Memisoglu                                              */
/*                                                                         */
/***************************************************************************/

#ifndef __CDMILIB_H
#define __CDMILIB_H

#include "sounddrv.h"
#include "ext386.h"

#ifndef __SOUND_BLOCK
#define __SOUND_BLOCK
typedef struct {
		unsigned int Speed;
		unsigned int Size;
		unsigned char Bits_per_Sample;
		unsigned char Channels;
		char Reserved[10];
	       } Sound_Block;
#endif




extern volatile unsigned int  CDMI_Pattern_No;
extern volatile unsigned int  CDMI_Beat_No;
extern volatile unsigned int  CDMI_Entry_No;
extern volatile unsigned int  CDMI_Volume;
extern          unsigned int  CDMI_Channels;
extern volatile unsigned int  CDMI_Tick;
extern          char far     *CDMI_DMA_Address;
extern volatile unsigned int  CDMI_DMA_Size;
extern volatile unsigned int  CDMI_Flags;
extern volatile unsigned long CDMI_Channel_Flags;
extern volatile unsigned int  CDMI_Speed;
extern volatile unsigned int  CDMI_Tempo;
extern          unsigned int  CDMI_Tick_Speed;
extern          l_ptr         CDMI_Song;
extern          unsigned int  CDMI_Version;

#ifndef __SONG_FLAGS
#define __SONG_FLAGS
	#define USE_16BIT	512
	#define USE_STEREO	256
	#define QUALITIY_MODE	64
	#define	BREAK_FLAG	16
	#define LOOP_FLAG	1
	#define HIGH_PASS	2
	#define MID_PASS	4
	#define LOW_PASS	8
#endif

extern int CDMI_Play_Sample (int,int);
extern int CDMI_Play_Song (int freq,int attr,SoundDrv *);
extern int CDMI_Stop_Song (void);
extern int CDMI_Set_Volume(int);
extern int CDMI_Jump(int);
extern int CDMI_Free_Song(void);
extern int CDMI_Load_MOD(char *);
extern int CDMI_Load_669(char *);
extern int CDMI_Load_S3M(char *);
extern int CDMI_Load_STM(char *);


#endif
