;[]------------------------------------------------------------------------[]
;|                                                                          |
;| (c) 1993,1994 by Marc van Shaney , aka Kaya Memisoglu                    |
;|                                                                          |
;| Dieser Assembler-Source-Code unterliegt dem Urheberrecht von Kaya        |
;| Memisoglu und darf auch nur mit seiner schriftlichen Genehmigung         |
;| in kommerziellen Programmen verwendet werden.                            |
;| Ich bernehme keinerlei Verantwortung fr eventuelle Schden,die dieses  |
;| Programm verursacht.                                                     |
;|                                                                          |
;|                                                                          |
;| 18.12.1994 Kaya Memisoglu                                                |
;|                                                                          |
;[]------------------------------------------------------------------------[]



FORMAT_MOD		equ   000444f4dh
FORMAT_669		equ   000393636h
FORMAT_STM		equ   0004d5453h
FORMAT_S3M		equ   0004d3353h
FORMAT_WOW		equ   000574f57h
FORMAT_OKT		equ   000544b4fh


TRUE        		equ   1
FALSE       		equ   -1

SH_ROW_SIZE		equ     2       	;Size of one row
SH_PATTERN_SIZE		equ     4               ;Size of one pattern
SH_SAMPLE_FREQ		equ	6		;C frequency
SH_PATTERN_COUNT	equ	8		;Number of patterns
SH_LIST_COUNT		equ	10		;Number of list entries
SH_START_SPEED		equ	12
SH_START_TEMPO		equ     14
SH_START_VOLUME		equ	16
SH_TICKS_PER_SECOND	equ	18
SH_PATTERN_PTR		equ	20
SH_INSTRUMENT_FMT	equ	24
SH_CHANNELS  		equ	28
SH_NAME			equ	32
SH_INSTRUMENTS		equ	64
SH_PATTERN_LIST		equ	4160
SH_PATTERN_LEN		equ	4288
SONG_HEADER_SIZE	equ	5000

SH_ENTRY_COUNT		equ	SH_LIST_COUNT
SH_ORDER_LIST		equ	SH_PATTERN_LIST

IH_SIZE			equ	SH_INSTRUMENTS
IH_LOOP_START		equ	SH_INSTRUMENTS+4
IH_LOOP_END		equ	SH_INSTRUMENTS+8
IH_VOLUME  		equ	SH_INSTRUMENTS+12
IH_RESAMPLE		equ	SH_INSTRUMENTS+14
IH_ADDRESS 		equ	SH_INSTRUMENTS+16
IH_COMPRESSION		equ	SH_INSTRUMENTS+20
IH_NAME			equ	SH_INSTRUMENTS+24
INSTRUMENT_HEADER_SIZE	equ	64


ENTRY_COUNT		equ     12
MEM_HANDLE		equ	32

MAX_CHANNELS		equ	18
MAX_INSTRUMENTS		equ	64
FX_CHANNELS		equ	MAX_CHANNELS-2

TIMER_MODE		equ	1024
USE_16_BIT		equ	512
USE_STEREO		equ	256
STEREO_MODE		equ	USE_STEREO
QUALITY_MODE		equ	64
BUFFER_READY_FLAG	equ	32
BREAK_FLAG		equ	16
LOW_PASS		equ	8
MID_PASS		equ	4
HIGH_PASS		equ	2
LOOP_FLAG		equ	1

;The following are the offsets in the channel-info table
CI_ADDRESS		equ	0
CI_SIZE			equ	4
CI_POSITION		equ	8
CI_LOOP_START		equ	12
CI_MAX_CX   		equ	16
CI_REST			equ	20
CI_INCREMENT		equ	22
CI_OVERFLOW		equ	24
CI_VOLUME		equ	26
CI_BALANCE		equ	27
CI_VOLUME_L             equ	28
CI_VOLUME_R		equ	29
CI_VOL_SLIDE		equ	30
CI_COMMAND		equ	31
CI_COM_VALUE		equ	32
CI_PERIOD		equ	34
CI_DESTINATION		equ	36
CI_INSTRUMENT		equ	38
CI_ARP_1		equ	40
CI_ARP_2		equ	42
CI_ARP_3		equ	44
CI_VIB_SPEED		equ	46
CI_VIB_DEPTH		equ	47
CI_VIB_POS		equ	48
CI_RESAMPLE		equ	50
CI_TRM_SPEED		equ	CI_VIB_SPEED
CI_TRM_DEPTH		equ	CI_VIB_DEPTH
CI_TRM_POS  		equ	CI_VIB_POS
CI_TRM_ON		equ	CI_VIB_SPEED
CI_TRM_OFF		equ	CI_VIB_DEPTH
CI_TRG_POS		equ	CI_VIB_POS
CI_REV_SPEED		equ	CI_VIB_SPEED
CI_REV_POS		equ	CI_VIB_DEPTH
CI_REV_SIZE		equ	CI_VIB_POS
CI_PANNING		equ	CI_BALANCE
CI_ENTRY_SIZE		equ	52

;This is a valid list of all special effects and their command-values
;!!! DO NOT CHANGE THESE BECAUSE THEY ARE INDICES OF A COMMAND TABLE !!!

SLIDE_UP		equ	1
SLIDE_DOWN		equ	2
TONE_PORTAMENTO		equ	3
VIBRATO			equ	4
TONE_AND_VOLSLIDE	equ	5
VIB_AND_VOLSLIDE	equ	6
TREMOLO			equ	7
PANNING			equ	8
SAMPLE_OFFSET		equ	9
VOLUME_SLIDE		equ	10
POSITION_JUMP		equ	11
SET_VOLUME		equ	12
PATTERN_BREAK		equ	13
ARPEGGIO		equ	14
SET_SPEED		equ	15
SET_FILTER		equ	16
FINE_SLIDE_UP		equ	17
FINE_SLIDE_DOWN		equ	18
GLISSANDO_CONTROL	equ	19
SET_VIBWAVE_FORM	equ	20
SET_FINETUNE		equ	21
LOOP_JUMP		equ	22
PATTERN_LOOP		equ	LOOP_JUMP
SET_TREMWAVE_FORM	equ	23
RETRIGGER_NOTE		equ	24
FINE_VOL_SLIDE_UP	equ	25
FINE_VOL_SLIDE_DOWN	equ	26
NOTE_CUT		equ	27
NOTE_DELAY		equ	28
PATTERN_DELAY		equ	29
FUNK_INVERT		equ	30
OKT_ARPEGGIO		equ	31
SET_TEMPO		equ	32
TREMOR			equ	33
SET_GLOBAL_VOLUME	equ	34
REVERSE_SAMPLE		equ	35
MAX_EFFECTS		equ	35


ifndef CDMI_SYSTEM_FILE

EXTRN C CDMI_Pattern_No:WORD
EXTRN C CDMI_Beat_No:WORD
EXTRN C CDMI_Entry_No:WORD
EXTRN C CDMI_DMA_Address:DWORD
EXTRN C CDMI_DMA_Size:WORD
EXTRN C CDMI_Flags:DWORD
EXTRN C CDMI_Channel_Flags:DWORD
EXTRN C CDMI_Volume:WORD
EXTRN C CDMI_Channels:WORD
EXTRN C CDMI_Tick:WORD
EXTRN C CDMI_Speed:WORD
EXTRN C CDMI_Tempo:WORD
EXTRN C CDMI_Song:DWORD
EXTRN C CDMI_Tick_Speed:WORD
EXTRN C CDMI_Version:WORD


EXTRN C CDMI_Load_669:PROC
EXTRN C CDMI_Load_MOD:PROC
EXTRN C CDMI_Load_S3M:PROC
EXTRN C CDMI_Load_STM:PROC
EXTRN C CDMI_Free_Song:PROC
EXTRN C CDMI_Play_Song:PROC
EXTRN C CDMI_Stop_Song:PROC
EXTRN C CDMI_Jump:PROC
EXTRN C CDMI_Set_Volume:PROC
EXTRN C CDMI_Play_Sample:PROC

endif