/***************************************************************************/
/*                                                                         */
/*                                                                         */
/*                   (c) 1993,1994 by Kaya Memisoglu                       */
/*                                    aka Marc van Shaney                  */
/*                                                                         */
/* Die kommerzielle Nutzung des Source-Codes ohne meine schriftliche       */
/* Genehmigung ist untersagt. Desweiteren hafte ich fr keinerlei          */
/* Schaden den das Programm verursacht.                                    */
/*                                                                         */
/* Geschrieben mit Borland C++ 3.1                                         */
/*     Borland C++ ist eingetragenes Warenzeichen der                      */
/*                                  Borland Inernational INC               */
/*                                                                         */
/*                                                                         */
/* 18.1.1994 - Kaya Memisoglu                                              */
/*                                                                         */
/***************************************************************************/


#ifndef __SOUNDDRV_H
#define __SOUNDDRV_H

#define SOUND_PLAYING		1
#define SOUND_READY		2
#define SOUND_RECORDING		4
#define SOUND_CAN_PLAY		1
#define SOUND_CAN_RECORD	2
#define SOUND_CAN_STEREO	4
#define SOUND_CAN_MONO		8
#define SOUND_CAN_8BIT		16
#define SOUND_CAN_16BIT		32
#define SOUND_USES_TIMER	64

#ifndef __SOUND_BLOCK
#define __SOUND_BLOCK
typedef struct {
		unsigned int Speed;
		unsigned int Size;
		unsigned char Bits_per_Sample;
		unsigned char Channels;
		char Reserved[10];
	       } Sound_Block;
#endif




typedef struct
	     {
	      char Ident[32];
	      char Type[16];
	      char Name[32];
	      int Version;
	      int Function_Count;
	      char *Driver_Setup;

	      int (*Init_Driver) (void);
	      int (*Exit_Driver) (void);
	      int (*Play_Voice) (Sound_Block *);
	      int (*Stop_Voice) (void);
	      int (*Record_Voice) (Sound_Block *);
	      int (*Set_Play_Handler) (int (*Handler) (void));
	      int (*Set_Record_Handler) (int (*Handler) (void));
	      int (*Set_Next_Block) (Sound_Block *);

              long Capabilities;
              int MaxRecordRate;
              int MaxPlayRate;
	      int Status;
	      char far *Voice;
	     } SoundDrv;


#endif